---
title: Library overview
description: Overview over all libraries that are natively available in LispPad.
order: 6
---

Below is a list of all libraries that are pre-packaged with LispPad. The core libraries are also documented in the
<a href="../media/lisppad_ref.pdf" target="_blank">LispPad Library Reference manual</a>.

## LispPad

- [`(lisppad applescript)`](7-0-lisppad-applescript.html)
- `(lisppad audio)`
- [`(lisppad location)`](7-0-lisppad-location.html)
- `(lisppad log)`
- [`(lisppad speech)`](7-0-lisppad-speech.html)
- [`(lisppad system)`](7-0-lisppad-system.html)
- [`(lisppad turtle)`](7-0-lisppad-turtle.html)

## LispKit

- [`(lispkit archive zip)`](7-5-lispkit-archive-zip.html)
- [`(lispkit base)`](7-5-lispkit-base.html)
- [`(lispkit box)`](7-5-lispkit-box.html)
- [`(lispkit bytevector)`](7-5-lispkit-bytevector.html)
- [`(lispkit char-set)`](7-5-lispkit-char-set.html)
- [`(lispkit char)`](7-5-lispkit-char.html)
- `(lispkit clos)`
- [`(lispkit combinator)`](7-5-lispkit-combinator.html)
- [`(lispkit comparator)`](7-5-lispkit-comparator.html)
- [`(lispkit control)`](7-5-lispkit-control.html)
- [`(lispkit core)`](7-5-lispkit-core.html)
- [`(lispkit csv)`](7-5-lispkit-csv.html)
- [`(lispkit datatype)`](7-5-lispkit-datatype.html)
- [`(lispkit date-time)`](7-5-lispkit-date-time.html)
- [`(lispkit debug)`](7-5-lispkit-debug.html)
- [`(lispkit disjoint-set)`](7-5-lispkit-disjoint-set.html)
- [`(lispkit draw turtle)`](7-5-lispkit-draw-turtle.html)
- [`(lispkit draw)`](7-5-lispkit-draw.html)
- [`(lispkit dynamic)`](7-5-lispkit-dynamic.html)
- [`(lispkit enum)`](7-5-lispkit-enum.html)
- `(lispkit graph)`
- [`(lispkit gvector)`](7-5-lispkit-gvector.html)
- [`(lispkit hashtable)`](7-5-lispkit-hashtable.html)
- [`(lispkit heap)`](7-5-lispkit-heap.html)
- [`(lispkit iterate)`](7-5-lispkit-iterate.html)
- `(lispkit json)`
- [`(lispkit list)`](7-5-lispkit-list.html)
- [`(lispkit log)`](7-5-lispkit-log.html)
- `(lispkit logic)`
- [`(lispkit markdown)`](7-5-lispkit-markdown.html)
- [`(lispkit match)`](7-5-lispkit-match.html)
- [`(lispkit math)`](7-5-lispkit-math.html)
- [`(lispkit object)`](7-5-lispkit-object.html)
- `(lispkit pdf)`
- [`(lispkit port)`](7-5-lispkit-port.html)
- `(lispkit prettify)`
- `(lispkit prolog)`
- [`(lispkit queue)`](7-5-lispkit-queue.html)
- [`(lispkit record)`](7-5-lispkit-record.html)
- [`(lispkit regexp)`](7-5-lispkit-regexp.html)
- [`(lispkit set)`](7-5-lispkit-set.html)
- [`(lispkit sqlite)`](7-5-lispkit-sqlite.html)
- [`(lispkit stack)`](7-5-lispkit-stack.html)
- [`(lispkit stream)`](7-5-lispkit-stream.html)
- [`(lispkit string)`](7-5-lispkit-string.html)
- `(lispkit sxml html)`
- `(lispkit sxml xml)`
- `(lispkit sxml)`
- [`(lispkit system os)`](7-5-lispkit-system-os.html)
- [`(lispkit system)`](7-5-lispkit-system.html)
- [`(lispkit test)`](7-5-lispkit-test.html)
- `(lispkit text-table)`
- [`(lispkit type)`](7-5-lispkit-type.html)
- [`(lispkit vector)`](7-5-lispkit-vector.html)
- `(lispkit wt-tree)`

## Scheme

### R7RS small

- `(scheme base)`
- `(scheme case-lambda)`
- `(scheme char)`
- `(scheme complex)`
- `(scheme cxr)`,
- `(scheme eval)`
- `(scheme file)`
- `(scheme inexact)`
- `(scheme lazy)`
- `(scheme load)`
- `(scheme process-context)`
- `(scheme read)`
- `(scheme repl)`
- `(scheme time)`
- `(scheme write)`
- `(scheme r5rs)`

### R7RS large

- `(scheme bitwise)`
- `(scheme box)`
- `(scheme charset)`
- `(scheme comparator)`
- `(scheme division)`
- `(scheme fixnum)`
- `(scheme generator)`
- `(scheme hash-table)`
- `(scheme ideque)`
- `(scheme list)`
- `(scheme mapping)`
- `(scheme red)`
- `(scheme rlist)`
- `(scheme set)`
- `(scheme sort)`
- `(scheme stream)`
- `(scheme text)`
- `(scheme vector)`

## SRFI

The following  [SRFI](https://srfi.schemers.org/) libraries are available in _LispPad_ natively. Others can be
install manually, typically with very little effort to port the implementation.

- [`(srfi 1)`](srfi/srfi-1.html) [List Library](https://srfi.schemers.org/srfi-1/srfi-1.html)
- [`(srfi 2)`](srfi/srfi-2.html) [AND-LET* - an AND with local bindings, a guarded LET* special form](https://srfi.schemers.org/srfi-2/srfi-2.html)
- [`(srfi 6)`](srfi/srfi-6.html) [Basic String Ports](https://srfi.schemers.org/srfi-6/srfi-6.html)
- [`(srfi 8)`](srfi/srfi-8.html) [receive - Binding to multiple values](https://srfi.schemers.org/srfi-8/srfi-8.html)
- [`(srfi 9)`](srfi/srfi-8.html) [Defining Record Types](https://srfi.schemers.org/srfi-9/srfi-9.html)
- [`(srfi 11)`](srfi/srfi-11.html) [Syntax for receiving multiple values](https://srfi.schemers.org/srfi-11/srfi-11.html)
- [`(srfi 14)`](srfi/srfi-14.html) [Character-set library](https://srfi.schemers.org/srfi-14/srfi-14.html)
- [`(srfi 16)`](srfi/srfi-16.html)  [Syntax for procedures of variable arity](https://srfi.schemers.org/srfi-16/srfi-16.html)
- [`(srfi 17)`](srfi/srfi-17.html) [Generalized set!](https://srfi.schemers.org/srfi-17/srfi-17.html)
- [`(srfi 19)`](srfi/srfi-19.html) [Time Data Types and Procedures](https://srfi.schemers.org/srfi-19/srfi-19.html)
- [`(srfi 23)`](srfi/srfi-23.html) [Error reporting mechanism](https://srfi.schemers.org/srfi-23/srfi-23.html)
- [`(srfi 26)`](srfi/srfi-26.html) [Notation for Specializing Parameters without Currying](https://srfi.schemers.org/srfi-26/srfi-26.html)
- [`(srfi 27)`](srfi/srfi-27.html) [Sources of Random Bits](https://srfi.schemers.org/srfi-27/srfi-27.html)
- [`(srfi 28)`](srfi/srfi-28.html) [Basic Format Strings](https://srfi.schemers.org/srfi-28/srfi-28.html)
- [`(srfi 31)`](srfi/srfi-31.html) [A special form rec for recursive evaluation](https://srfi.schemers.org/srfi-31/srfi-31.html)
- [`(srfi 33)`](srfi/srfi-33.html) [Integer Bitwise-operation Library](https://srfi.schemers.org/srfi-33/srfi-33.html)
- [`(srfi 34)`](srfi/srfi-34.html) [Exception Handling for Programs](https://srfi.schemers.org/srfi-34/srfi-34.html)
- [`(srfi 35)`](srfi/srfi-35.html) [Conditions](https://srfi.schemers.org/srfi-35/srfi-35.html)
- [`(srfi 39)`](srfi/srfi-39.html) [Parameter objects](https://srfi.schemers.org/srfi-39/srfi-39.html)
- [`(srfi 41)`](srfi/srfi-41.html) [Streams](https://srfi.schemers.org/srfi-41/srfi-41.html)
- [`(srfi 46)`](srfi/srfi-46.html) [Basic Syntax-Rules Extensions](https://srfi.schemers.org/srfi-46/srfi-46.html)
- [`(srfi 48)`](srfi/srfi-48.html) [Intermediate Format Strings](https://srfi.schemers.org/srfi-48/srfi-48.html)
- [`(srfi 51)`](srfi/srfi-51.html) [Handling rest list](https://srfi.schemers.org/srfi-51/srfi-51.html)
- [`(srfi 54)`](srfi/srfi-54.html) [Formatting](https://srfi.schemers.org/srfi-54/srfi-54.html)
- [`(srfi 55)`](srfi/srfi-55.html) [`require-extension`](https://srfi.schemers.org/srfi-55/srfi-55.html)
- [`(srfi 63)`](srfi/srfi-63.html) [Homogeneous and Heterogeneous Arrays](https://srfi.schemers.org/srfi-63/srfi-63.html)
- [`(srfi 64)`](srfi/srfi-64.html) [A Scheme API for test suites](https://srfi.schemers.org/srfi-64/srfi-64.html)
- [`(srfi 69)`](srfi/srfi-69.html) [Basic hash tables](https://srfi.schemers.org/srfi-69/srfi-69.html)
- [`(srfi 87)`](srfi/srfi-87.html) [`=>` in case clauses](https://srfi.schemers.org/srfi-87/srfi-87.html)
- [`(srfi 95)`](srfi/srfi-95.html) [Sorting and Merging](https://srfi.schemers.org/srfi-95/srfi-95.html)
- [`(srfi 98)`](srfi/srfi-98.html) [An interface to access environment variables](https://srfi.schemers.org/srfi-98/srfi-98.html)
- [`(srfi 101)`](srfi/srfi-101.html) [Purely Functional Random-Access Pairs and Lists](https://srfi.schemers.org/srfi-101/srfi-101.html)
- [`(srfi 111)`](srfi/srfi-111.html) [Boxes](https://srfi.schemers.org/srfi-111/srfi-111.html)
- [`(srfi 112)`](srfi/srfi-112.html) [Environment inquiry](https://srfi.schemers.org/srfi-112/srfi-112.html)
- [`(srfi 113)`](srfi/srfi-113.html) [Sets and bags](https://srfi.schemers.org/srfi-113/srfi-113.html)
- [`(srfi 121)`](srfi/srfi-121.html) [Generators](https://srfi.schemers.org/srfi-121/srfi-121.html)
- [`(srfi 125)`](srfi/srfi-125.html) [Intermediate hash tables](https://srfi.schemers.org/srfi-125/srfi-125.html)
- [`(srfi 128)`](srfi/srfi-128.html) [Comparators](https://srfi.schemers.org/srfi-128/srfi-128.html)
- [`(srfi 129)`](srfi/srfi-129.html) [Titlecase procedures](https://srfi.schemers.org/srfi-129/srfi-129.html)
- [`(srfi 132)`](srfi/srfi-132.html) [Sort Libraries](https://srfi.schemers.org/srfi-132/srfi-132.html)
- [`(srfi 133)`](srfi/srfi-133.html) [Vector Library](https://srfi.schemers.org/srfi-133/srfi-133.html)
- [`(srfi 134)`](srfi/srfi-134.html) [Immutable Deques](https://srfi.schemers.org/srfi-134/srfi-134.html)
- [`(srfi 135)`](srfi/srfi-135.html) [Immutable Texts](https://srfi.schemers.org/srfi-135/srfi-135.html)
- [`(srfi 137)`](srfi/srfi-137.html) [Minimal Unique Types](https://srfi.schemers.org/srfi-137/srfi-137.html)
- [`(srfi 142)`](srfi/srfi-142.html) [Bitwise Operations](https://srfi.schemers.org/srfi-142/srfi-142.html)
- [`(srfi 143)`](srfi/srfi-143.html) [Fixnums](https://srfi.schemers.org/srfi-143/srfi-143.html)
- [`(srfi 145)`](srfi/srfi-145.html) [Assumptions](https://srfi.schemers.org/srfi-145/srfi-145.html)
- [`(srfi 146)`](srfi/srfi-146.html) [Mappings](https://srfi.schemers.org/srfi-146/srfi-146.html)
- [`(srfi 151)`](srfi/srfi-151.html) [Bitwise Operations](https://srfi.schemers.org/srfi-151/srfi-151.html)
- [`(srfi 152)`](srfi/srfi-152.html) [String Library](https://srfi.schemers.org/srfi-152/srfi-152.html)
- [`(srfi 154)`](srfi/srfi-154.html) [First-class dynamic extents](https://srfi.schemers.org/srfi-154/srfi-154.html)
- [`(srfi 155)`](srfi/srfi-155.html) [Promises](https://srfi.schemers.org/srfi-155/srfi-155.html)  
- [`(srfi 158)`](srfi/srfi-158.html) [Generators and Accumulators](https://srfi.schemers.org/srfi-158/srfi-158.html)
- [`(srfi 161)`](srfi/srfi-161.html) [Unifiable Boxes](https://srfi.schemers.org/srfi-161/srfi-161.html)
- [`(srfi 162)`](srfi/srfi-162.html) [Comparators sublibrary](https://srfi.schemers.org/srfi-162/srfi-162.html)
- [`(srfi 165)`](srfi/srfi-165.html) [The Environment Monad](https://srfi.schemers.org/srfi-165/srfi-165.html)
- [`(srfi 167)`](srfi/srfi-167.html) [Ordered Key Value Store](https://srfi.schemers.org/srfi-167/srfi-167.html)
- [`(srfi 173)`](srfi/srfi-173.html) [Hooks](https://srfi.schemers.org/srfi-173/srfi-173.html)
- [`(srfi 174)`](srfi/srfi-174.html) [POSIX Timespecs](https://srfi.schemers.org/srfi-174/srfi-174.html)
- [`(srfi 175)`](srfi/srfi-175.html) [ASCII Character Library](https://srfi.schemers.org/srfi-175/srfi-175.html)
- [`(srfi 177)`](srfi/srfi-177.html) [Portable keyword arguments](https://srfi.schemers.org/srfi-177/srfi-177.html)
- [`(srfi 180)`](srfi/srfi-180.html) [JSON](https://srfi.schemers.org/srfi-180/srfi-180.html)
- [`(srfi 189)`](srfi/srfi-189.html) [Maybe and Either: optional container types](https://srfi.schemers.org/srfi-189/srfi-189.html)
- [`(srfi 194)`](srfi/srfi-194.html) [Random data generators](https://srfi.schemers.org/srfi-194/srfi-194.html)
- [`(srfi 195)`](srfi/srfi-195.html) [Multiple-value boxes](https://srfi.schemers.org/srfi-195/srfi-195.html)
- [`(srfi 196)`](srfi/srfi-196.html) [Range Objects](https://srfi.schemers.org/srfi-196/srfi-196.html)
- [`(srfi 204)`](srfi/srfi-204.html) [Wright-Cartwright-Shinn Pattern Matcher](https://srfi.schemers.org/srfi-204/srfi-204.html)
- [`(srfi 209)`](srfi/srfi-209.html) [Enums and Enum Sets](https://srfi.schemers.org/srfi-209/srfi-209.html)
- [`(srfi 210)`](srfi/srfi-210.html) [Procedures and Syntax for Multiple Values](https://srfi.schemers.org/srfi-210/srfi-210.html)
- [`(srfi 214)`](srfi/srfi-214.html) [Flexvectors](https://srfi.schemers.org/srfi-214/srfi-214.html)
- [`(srfi 215)`](srfi/srfi-215.html) [Central Log Exchange](https://srfi.schemers.org/srfi-215/srfi-215.html)
- [`(srfi 216)`](srfi/srfi-216.html) [SICP Prerequisites](https://srfi.schemers.org/srfi-216/srfi-216.html)  
- [`(srfi 219)`](srfi/srfi-219.html) [Define higher-order lambda](https://srfi.schemers.org/srfi-219/srfi-219.html)
- [`(srfi 221)`](srfi/srfi-221.html) [Generator/accumulator sub-library](https://srfi.schemers.org/srfi-221/srfi-221.html)
- [`(srfi 222)`](srfi/srfi-222.html) [Compound Objects](https://srfi.schemers.org/srfi-222/srfi-222.html)
- [`(srfi 223)`](srfi/srfi-223.html) [Generalized binary search procedures](https://srfi.schemers.org/srfi-223/srfi-223.html)


## Third-party

- `(third-party adapton mini)`
